package denim;

/*
 * Created by Work on 31/10/2016.
 */
import beast.core.BEASTObject;
import beast.core.Description;
import beast.core.Input;
import beast.core.Loggable;
import beast.evolution.tree.Node;
import beast.evolution.tree.TreeInterface;

import java.io.PrintStream;
import java.util.List;

@Description("Statistic that counts the number of clusters (equals one more than the number of collapsed nodes)")

public class BirthDeathCollapseNClustersStatistic extends BEASTObject implements Loggable {
    @SuppressWarnings({"CanBeFinal", "WeakerAccess"})
    public Input<TreeInterface> smcTree =
            new Input<>("smcTree",
                    "Species or minimal clusters  tree", Input.Validate.REQUIRED);


    // bdcm not used here but it is in templates and XML files
    @SuppressWarnings("UnusedDeclaration")
    public Input<BirthDeathCollapseModel> bdcm =
            new Input<>("bdcm", "The birth death collapse model", Input.Validate.REQUIRED);



    @Override
    public void initAndValidate() {
    }



    @Override
    public void init(PrintStream out) {
        out.print("NClusters\t");
    }

    @Override
    public void log(long nSample, PrintStream out) {
        out.print(""+getStatisticValue() + "\t");
    }

    @Override
    public void close(PrintStream out) {
        // nothing to do
    }

    private double getStatisticValue() {
        List<Node> inodes = smcTree.get().getInternalNodes();
        int n =  0;
        for (Node node : inodes) {
            double h = node.getHeight();
            if (!BirthDeathCollapseModel.belowCollapseHeight(h)) {
                n++;
            }
        }
        return n+1;
    }


}
